function[pmi, new_total_A] = reduce_step(base_pmi, total_A)
%% this function performs one iteration of the quantization reduction

expts = max(size(total_A));
thresholds = size(total_A{1}, 2);

%% We have to test all possible threshold pairs (i, i+1), for i in
%% 1:thresholds-1.  At the end, we choose the one which loses the "least
%% amount of information" -- that is, the thresholds to collapse which
%% minimize the before-and-after difference, TMI(L)-TMI(L-1).
for i = 1:thresholds-1
    for e = 1:expts
        temp_total_A{e} = collapse(total_A{e}, i);
    end
    
    %% The call to mutual_info is in this function...
    scores(i) = pairwise_mutual_info(temp_total_A);
    
    diffs(i) = base_pmi - scores(i);
end

[vmin, imin] = min(diffs);
for e = 1:expts
    new_total_A{e} = collapse(total_A{e}, imin);
end
pmi = scores(imin);
fprintf(1, 'Reduction %d/%d: (%d <--> %d), TMI: %1.4f (%1.4f)\n', thresholds, (thresholds-1), imin, (imin+1), pmi, diffs(imin));